unit Drive;
{$X+,V-}
interface
uses Drivers, Objects, Views, Dialogs, App, Dos, MsgBox, Strings, Box_Obj;

type    PDeviceCollection = ^TDeviceCollection;
                        TDeviceCollection = object(TCollection)
                                procedure FreeItem(Item: Pointer); virtual;
                 end;

                 POkListBox = ^TOkListBox;
                 TOkListBox = object(TListBox)
                         procedure SelectItem(Item: Integer); virtual;
                 end;

                 PDeviceRec = ^TDeviceRec;
                 TDeviceRec = record
                         LocalName      : Char;
                 end;

                 PBoxDrive = ^TBoxDrive;
                 TBoxDrive = object(TBox)
                         constructor Init(var Bounds: TRect);
                         procedure       Draw; virtual;
                 end;

function SelectDrive: Char;

implementation
constructor TBoxDrive.Init(var Bounds: TRect);
begin
        TView.Init(Bounds);
end;

procedure TBoxDrive.Draw;
var B: TDrawBuffer;
                C: Byte;
                I: byte;
begin
        C:=GetColor(1);
        MoveChar(B,' ',C,Size.X);
        for i:=0 to Size.Y-1 do WriteLine(0,I,Size.X,1,B);
        MoveChar(B,' ',C,Size.X);
        MoveChar(B,'',C,Size.X);   WordRec(B[0]).Lo:=218; WordRec(B[Size.X-1]).Lo:=191; WriteLine(0,0,Size.X,1,B);
        MoveChar(B,'',C,Size.X);   WordRec(B[0]).Lo:=192; WordRec(B[Size.X-1]).Lo:=217; WriteLine(0,Size.Y-1,Size.X,1,B);
        MoveChar(B,' ',C,Size.Y-2); MoveChar(B,'',C,Size.Y-2); WriteLine(0,1,1,Size.Y-2,B); WriteLine(Size.X-1,1,1,Size.Y-2,B);
end;

procedure TDeviceCollection.FreeItem(Item: Pointer);
var DeviceRec : PDeviceRec absolute Item;
begin
        Dispose(DeviceRec);
end;

function DriveValid(Drive: Char): Boolean; assembler;
asm
                 MOV    AH,19H
                 INT    21H
                 MOV    BL,AL
                 MOV    DL,Drive
                 SUB    DL,'A'
                 MOV    AH,0EH
                 INT    21H
                 MOV    AH,19H
                 INT    21H
                 MOV    CX,0
                 CMP    AL,DL
                 JNE    @@1
                 MOV    CX,1
                 MOV    DL,BL
                 MOV    AH,0EH
                 INT    21H
@@1: XCHG AX,CX
end;

function ValidDriveList: PStringCollection;
var  DriveList : PStringCollection;
                 DeviceList: PDeviceCollection;
                 Device          : PDeviceRec;
                 Drive           : Char;
                 S                               : String;
                 SR                      : SearchRec;
                 function DriveMatch(P:PDeviceRec):Boolean;far;
                 begin
                         DriveMatch:=Drive=P^.LocalName;
                 end;
begin
        DriveList :=New(PStringCollection,Init(26,0));
        DeviceList:=NIL;
        for Drive :='A' to 'Z' do begin
                if DriveValid(Drive) then begin
                        S:=Drive+':';
                        if Drive in ['C'..'Z'] then begin
                                FindFirst(Drive+':\*.*', VolumeID, SR);
        if DosError=0 then begin
          delete(SR.NAme,9,1);
          S:=S+'  '+SR.Name;
        end;
                        end;
                        if DeviceList<>nil then Device:=DeviceList^.FirstThat(@DriveMatch);
                        DriveList^.Insert(NewStr(S));
                end;
        end;
        if DriveList^.Count=0 then begin
                Dispose(DriveList,Done);
                DriveList:=nil;
        end;
        ValidDriveList:=DriveList;
        if DeviceList<>nil then Dispose(DeviceList,Done);
end;

function SelectDrive : Char;
var  R         : TRect;
     D         : PDialog;
     LB        : PListBox;
     SB        : PScrollBar;
     P         : PString;
     DriveList : PStringCollection;
     CurDir    : String;
function IsCurrentDirectory(Dir:PString):Boolean;far;
begin
 IsCurrentDirectory:=Dir^[1]=CurDir[1];
end;
begin
  GetDir(0, CurDir);
  SelectDrive:=' ';
  DriveList  :=ValidDriveList;
  if DriveList=nil then begin
    MessageBox(#3' ᪮ ன'#13#3' 롮.',nil,mfError+mfOKButton);
    Exit;
  end;
  R.Assign(0,0,35,10);
  D:=New(PDialog,Init(R,'롮 ᪠'));
  with D^ do begin
    Options:=Options or ofCentered;
    R.Assign(2,2,21,9);  Insert(New(PBoxDrive,Init(R)));
    R.Assign(20,3,21,8); SB:=New(PScrollBar,Init(R)); Insert(SB);
    R.Assign(3,3,20,8);  LB:=New(POkListBox,Init(R,1,SB)); Insert(LB);
    LB^.NewList(DriveList);
    R.Assign(21,5,33,7); Insert(New(PButton,Init(R,'~~롮',cmOK,bfDefault)));
    R.Move(0,2);         Insert(New(PButton,Init(R,'~~⪠',cmCancel,bfNormal)));
    SelectNext(False);
  end;
  P:=DriveList^.FirstThat(@IsCurrentDirectory);
  if P<>nil then LB^.FocusItem(DriveList^.IndexOf(P));
  if Desktop^.ExecView(D)=cmOK then begin
    P:=DriveList^.At(LB^.Focused);
    if P<>nil then SelectDrive:=P^[1];
  end;
  Dispose(DriveList,Done);
  Dispose(D,Done);
end;

{ TOkListBox }
procedure TOkListBox.SelectItem(Item: Integer);
var E: TEvent;
begin
        inherited SelectItem(Item);
        with E do begin
                What            :=evCommand;
                Command :=cmOk;
                InfoPtr :=nil;
        end;
        PutEvent(E);
end;

end.

